/* D:\Rexx\isOlderFile.Cmd
 * Friday December 27, 1996 11:09:45 pm
 * Ŀ
 *     Fred Peachman                             
 *     Brookfield, Ohio 44403                    
 *     av023@yfn2.ysu.edu -or- fpeachm@ibm.net   
 * 
 */
thisFile ='isOlderFile'
_FileType = 'CMD'
debug = 1

parse source . cmdType .
if cmdType = 'COMMAND' then do
  parse arg cmdLine
  if cmdLine = '?' | cmdLine = '' then do
    call showhelp
    exit -1
    end
  if pos(',', cmdLine) > 0 then do
    parse value cmdLine with file1','file2
    end
  else do
    parse arg file1 file2
    end
  end
else do
  file1 = arg(1)
  file2 = arg(2)
  end
do i = 1 to 2
  interpret 'file.'i '=strip(file'i')'
  if file.i = '' then do
    call showHelp
    say
    say '************************************************************'
    say thisfile': ERROR -'
    say '   File #'i 'wasn''t specified.'
    say
    return -1
    end
  if stream(file.i,'C','QUERY EXISTS') = '' then do
    say
    say '************************************************************'
    say thisfile': ERROR -'
    say file.i 'doesn''t exist. Can''t make comparison.'
    return -1
    end
  dateInfo = stream(file.i, 'C','QUERY DATETIME')
    /* return something like "12-27-96  23:03:42" */
  parse value dateinfo with v.i.2'-'v.i.3'-'v.i.1 v.i.4':'v.i.5':'v.i.6
    do j = 1 to 6
      v.j = strip(v.j)
      end
  end
do i = 1 to 6
  if v.i.1 < v.i.2 then do
    if cmdType = 'COMMAND' then say file.1 'is older than' file.2
    return 1
    end
  else if v.i.1 > v.i.2 then do
    if cmdType = 'COMMAND' then say file.1 'is newer than' file.2
    return 0
    end
  end
if cmdType = 'COMMAND' then say file.1 'is the same date as' file.2
return 0

showHelp:
say
say thisfile
say
say 'SYNTAX:'
say '   'thisfile '<file1> <file2>'
say
say 'RETURNS:'
say '   1 if file1 is older than file2.' 
say '   0 if not.'
return 0
